;; 7of9/theme.jl
;; $Id$

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(let*
    ;; images
    ((bottom-left-i (make-image "bl.png"))
     ;; 16x16
     (bottom-right-i (make-image "br.png"))
     
     ;; 225x15
     (title-i (list (make-image "titleunfocus.png")
		    (make-image "tilefocus.png")))

     (hbar-i (make-image "bottom.png"))
     (vbar-i (make-image "vbar.png"))

     ;; 16x16
     (menu-i (list (make-image "menuun.png")
		   (make-image "menu.png")))

     ;; 16x16
     (close-i (list (make-image "closeun.png")
		    (make-image "close.png")))


     ;; frame definitions

     (frame `(((background . ,menu-i)
	       (left-edge . -3)
	       (top-edge . -19)
	       (class . menu-button))
	      ;; title bar
	      ((background . ,title-i)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 16)
	       (right-edge . 16)
	       (top-edge . -19)
	       (class . title))
	      ;; close button
	      ((background . ,close-i)
	       (right-edge . -3)
	       (top-edge . -19)
	       (class . close-button))
	      ;; left frame
	      ((background . ,vbar-i)
	       (left-edge . -3)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ;; right frame
	      ((background . ,vbar-i)
	       (right-edge . -3)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ;; bottom frame
	      ((background . ,hbar-i)
	       (left-edge . 26)
	       (right-edge . 26)
	       (bottom-edge . -7)
	       (class . bottom-border))
	      ;; bottom-left corner
	      ((background . ,bottom-left-i)
	       (left-edge . -3)
	       (bottom-edge . -7)
	       (class . bottom-left-corner))
	      ;; bottom-right corner
	      ((background . ,bottom-right-i)
	       (right-edge . -3)
	       (bottom-edge . -7)
	       (class . bottom-right-corner))))

     (shaped-frame `(((background . ,menu-i)
		      (left-edge . -3)
		      (top-edge . -19)
		      (class . menu-button))
		     ;; title bar
		     ((background . ,title-i)
		      (foreground . "white")
		      (text . ,window-name)
		      (x-justify . center)
		      (y-justify . center)
		      (left-edge . 16)
		      (right-edge . 16)
		      (top-edge . -19)
		      (class . title))

		     ;; close button
		     ((background . ,close-i)
		      (right-edge . -3)
		      (top-edge . -19)
		      (class . close-button))))

     (transient-frame `(((background . ,title-i)
			 (foreground . "white")
			 (text . ,window-name)
			 (x-justify . center)
			 (y-justify . center)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -19)
			 (class . title))
			;; bottom frame
			((background . ,hbar-i)
			 (left-edge . 3)
			 (right-edge . 3)
			 (bottom-edge . -7)
			 (class . bottom-border))
			;; bottom-left corner
			((background . ,bottom-left-i)
			 (left-edge . -30)
			 (bottom-edge . -7)
			 (class . bottom-left-corner))
			;; left frame
			((background . ,vbar-i)
			 (left-edge . -3)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . left-border))
			;; right frame
			((background . ,vbar-i)
			 (right-edge . -3)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . right-border))
			;; bottom-right corner
			((background . ,bottom-right-i)
			 (right-edge . -30)
			 (bottom-edge . -7)
			 (class . bottom-right-corner))))

     (shaped-transient-frame `(((background . ,title-i)
				(foreground . "white")
				(text . ,window-name)
				(x-justify . center)
				(y-justify . center)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -19)
				(class . title)))))

  (add-frame-style '7of9
		   (lambda (w type)
		     ;; called to produce a frame definition
		     ;; for window W (of type TYPE)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'transient)
			    transient-frame)
			((eq type 'shaded)
                            shaped-frame)

			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame)))))
